#property copyright "Copyright  2010, sangmane."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 White
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 Red

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2

#property indicator_level1 0
//---- input parameters
extern int       Period_Q=14;
extern int       Period_R=10;
extern int       Period_S=14;
extern int       Signal=5;
//---- buffers
double SMI[],SMI_MA[];
double EMA_SM[], EMA2_SM[];
double EMA_HQ[], EMA2_HQ[];
double HistoUp[],HistoDn[];
double SC_R;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);


   SetIndexBuffer(0,HistoUp);           
   SetIndexBuffer(1,HistoDn);    
   SetIndexBuffer(2,SMI);
   SetIndexBuffer(3,SMI_MA);    
  
   SetIndexBuffer(4,EMA_SM);
   SetIndexBuffer(5,EMA2_SM);
   SetIndexBuffer(6,EMA_HQ);
   SetIndexBuffer(7,EMA2_HQ);

   IndicatorShortName("SMI("+Period_Q+","+Period_R+","+Period_S+","+Signal+")");
   SC_R = 2.0/(Period_R+1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int    counted_bars=IndicatorCounted();
    if(counted_bars<0) return(-1);
    if(counted_bars>0) counted_bars--;
    int i, limit = Bars-counted_bars;

    for (i=limit;i>=0;i--)
    {
      double HQ=High[iHighest(NULL,0,MODE_HIGH,Period_Q,i)]-Low[iLowest(NULL,0,MODE_LOW,Period_Q,i)];
      double SM=Close[i]-(High[iHighest(NULL,0,MODE_HIGH,Period_Q,i)]+Low[iLowest(NULL,0,MODE_LOW,Period_Q,i)])/2;//Median_Q[i];
      if(i==Bars-2)
      {
        EMA_SM[i+1] = 0;
        EMA_HQ[i+1] = 0;
      }      
      EMA_SM[i] = EMA_SM[i+1]+SC_R*(SM-EMA_SM[i+1]);
      EMA_HQ[i] = EMA_HQ[i+1]+SC_R*(HQ-EMA_HQ[i+1]);
    }
    for (i=limit;i>=0;i--)    
    {
      EMA2_SM[i] = iMAOnArray(EMA_SM,0,Period_S,0,MODE_EMA,i);
      EMA2_HQ[i] = iMAOnArray(EMA_HQ,0,Period_S,0,MODE_EMA,i);
      if(EMA2_HQ[i]!=0)
        SMI[i]=100*EMA2_SM[i]/0.5/MathMax(Point,EMA2_HQ[i]);
      else
        SMI[i] = 0;
    }

    for (i=limit;i>=0;i--)
    {
      SMI_MA[i] = iMAOnArray(SMI,0,Signal,0,MODE_EMA,i);
      double TheGreatOsma =SMI[i]-SMI_MA[i];
      if(TheGreatOsma>=0)
        HistoUp[i]=TheGreatOsma;
      else
        HistoDn[i]=TheGreatOsma;
    }
      
   return(0);
  }
//+------------------------------------------------------------------+